#ifndef _CAMERA_H_
#define _CAMERA_H_

/* Camera Declaration - Viewing Component - Model Branch
 *
 * Camera.h
 * fwk4gps version 1.0
 * gam666/dps901
 * August 30 2010
 * copyright (c) 2010 Chris Szalwinski 
 * distributed under TPL - see ../Licenses.txt
 */

#include "iCamera.h" // for the Camera Interface

//-------------------------------- Camera -------------------------------------
//
// The Camera Primitive represents a single viewpoint in the Viewing Component
//
class iViewing;

class Camera : public iCamera {

    static iViewing* coordinator; // points to the Viewing Object

    iContext*        context;     // points to the Context object
    const iFrame*    host;        // points to the host frame, if any
	float ryl, rxl; // used to keep track of the mouse rotation amounts in order to rotate the camera
    Camera(iContext*); // creates
	Camera(const Camera& c);            // prevents copying
	Camera& operator=(const Camera& c); // prevents assignment
    virtual ~Camera();

  public:
	friend iCamera* CreateCamera(iContext*);
	static void isCoordinatedBy(iViewing* viewing) { coordinator = viewing; }
    // initialization function
    void   attach(const iFrame*);
	// execution function
    void   update(int delta);
	// termination function
	void   Delete() const { delete this; }
};

#endif
